<?php
    /**
     * Webkul Software.
     *
     * @category  Webkul
     * @package   Webkul_Mobikul
     * @author    Webkul
     * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
     * @license   https://store.webkul.com/license.html
     */

    namespace Webkul\Mobikul\Block\Adminhtml\Notification\Edit\Tab;
    use Webkul\Mobikul\Controller\RegistryConstants;

    class CustomCollectionNotification extends \Magento\Backend\Block\Template  {

        public $_urlHelper;
        public $_jsonHelper;
        protected $request;
        protected $_combine;
        protected $_notificationRepository;

        public function __construct(
            \Magento\Framework\App\Request\Http $request,
            \Magento\Backend\Model\UrlInterface $urlHelper,
            \Magento\Framework\Json\Helper\Data $jsonHelper,
            \Magento\Backend\Block\Template\Context $context,
            \Magento\SalesRule\Model\Rule\Condition\Product\Combine $combine,
            \Webkul\Mobikul\Api\NotificationRepositoryInterface $notificationRepository,
            array $data = []
        ) {
            $this->request                 = $request;
            $this->_combine                = $combine;
            $this->_urlHelper              = $urlHelper;
            $this->_jsonHelper             = $jsonHelper;
            $this->_notificationRepository = $notificationRepository;
            parent::__construct($context, $data);
        }

        protected function _prepareLayout()     {
            $this->setTemplate("notification/customcollectionnotification.phtml");
        }

        public function getAssignedAttributes(){
            $options = $this->_combine->getNewChildSelectOptions();
            return $options[3]["value"];
        }

        public function getProductsJson(){
            $notification = $this->getNotificationData();
            if(count($notification) && $notification["collection_type"] == "product_ids"){
                $filterData = unserialize($notification["filter_data"]);
                $productIds = explode(",", $filterData);
            }
            else
                $productIds = [];
            return $this->_jsonHelper->jsonEncode($productIds);
        }

        public function getNotificationData()   {
            $notificationId = $this->_request->getParam("id");
            if($notificationId){
                $notification = $this->_notificationRepository->getById($notificationId);
                return $notification->getData();
            }
            else{
                return [];
            }
        }

    }