<?php
/**
 * Webkul_Mobikul Adminhtml Block.
 * @category  Webkul
 * @package   Webkul_Mobikul
 * @author    Webkul
 * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace Webkul\Mobikul\Block\Adminhtml\Product;

class TextureImage extends \Magento\Backend\Block\Template
{
    /**
     * @var string
     */
    protected $_template = 'product/textureimage.phtml';

    /**
     * @param \Magento\Backend\Block\Template\Context   $context
     * @param \Magento\Framework\Registry               $coreRegistry
     * @param array                                     $data = []
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $coreRegistry,
        array $data = []
    ) {
        $this->coreRegistry = $coreRegistry;
        parent::__construct($context, $data);
    }

    /**
     * getAuctionType
     * @return false|string
     */
    public function getTextureImageData()
    {
        $product           = $this->coreRegistry->registry('product');
        $proType           = $this->getRequest()->getParam('type');
        $proType           = $proType ? $proType : $product->getTypeId();
        $arIosModel        = "";
        $arAndroidModel    = "";
        $arIosModelArr     = explode("/", $product->getArModelFileIos());
        $arAndroidModelArr = explode("/", $product->getArModelFileAndroid());
        
        if (!empty($arAndroidModelArr)) {
            $arAndroidModel = $arAndroidModelArr[count($arAndroidModelArr) - 1];
        }
        
        if (!empty($arIosModelArr)) {
            $arIosModel = $arIosModelArr[count($arIosModelArr) - 1];
        }
        
        $arData = [
            'product_type' => $proType,
            'ar_type' => $product->getArType(),
            'texture_images' => $product->getArTextureImage(),
            'ar_model_file_android_model' => $arAndroidModel,
            'ar_model_file_ios_model' => $arIosModel
        ];
        return $arData;
    }
}
