<?php
    /**
     * Webkul Software.
     *
     * @category  Webkul
     * @package   Webkul_Mobikul
     * @author    Webkul
     * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
     * @license   https://store.webkul.com/license.html
     */

    namespace Webkul\Mobikul\Block;
    use Magento\Framework\Stdlib\CookieManagerInterface;

    class Downloadlink extends \Magento\Framework\View\Element\Template    {

        const COOKIE_NAME = "downloadlink";
        public $_urlHelper;
        protected $_helper;
        public $_jsonHelper;
        protected $_assetRepo;
        protected $_cookieManager;

        public function __construct(
            \Magento\Framework\Url $urlHelper,
            \Webkul\Mobikul\Helper\Data $helper,
            CookieManagerInterface $cookieManager,
            \Magento\Framework\Json\Helper\Data $jsonHelper,
            \Magento\Framework\View\Element\Template\Context $context,
            array $data = []
        ) {
            $this->_helper        = $helper;
            $this->_urlHelper     = $urlHelper;
            $this->_assetRepo     = $context->getAssetRepository();
            $this->_jsonHelper    = $jsonHelper;
            $this->_cookieManager = $cookieManager;
            parent::__construct($context, $data);
        }

        public function getPlaystoreImageUrl()  {
            return $this->_assetRepo->getUrl("Webkul_Mobikul::images/google-play.png");
        }

        public function getAppstoreImageUrl()   {
            return $this->_assetRepo->getUrl("Webkul_Mobikul::images/app-store.png");
        }

        public function getCloseButtonImageUrl()    {
            return $this->_assetRepo->getUrl("Webkul_Mobikul::images/close.png");
        }

        // public function getPlaystoreUrl()    {
        //     // $this->_urlHelper->
        //     // $this->resultRedirectFactory->create()->setPath(
        //     //     "mobikulhttp/downloadlink/openapp",
        //     //     ["_secure" => $this->getRequest()->isSecure()]
        //     // );
        //     return $this->_helper->getConfigData("mobikul/appdownload/androidlink");
        // }

        public function getAppstoreUrl()    {
            return $this->_helper->getConfigData("mobikul/appdownload/ioslink");
        }

        public function getThemeName()    {
            return $this->_helper->getConfigData("mobikul/appdownload/downloadlinktheme");
        }

        public function toShow(){
            return (bool)$this->_cookieManager->getCookie(self::COOKIE_NAME);
        }

    }