<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Adminhtml;
    use Magento\Backend\App\Action\Context;
    use Magento\Catalog\Api\ProductRepositoryInterface;
    use Magento\Framework\App\Filesystem\DirectoryList;
    use Magento\Catalog\Api\CategoryRepositoryInterface;
    use Webkul\Mobikul\Api\Data\NotificationInterfaceFactory;

    abstract class Notification extends \Magento\Backend\App\Action     {

        protected $_date;
        protected $_filter;
        protected $_helper;
        protected $_jsonHelper;
        protected $_entityType;
        protected $_productType;
        protected $_storeManager;
        protected $_attributeSet;
        protected $_mediaDirectory;
        protected $_entityAttribute;
        protected $_productResource;
        protected $_categoryResource;
        protected $_resultJsonFactory;
        protected $_resultPageFactory;
        protected $_collectionFactory;
        protected $_coreRegistry = null;
        protected $_fileUploaderFactory;
        protected $_resultForwardFactory;
        protected $_notificationRepository;
        protected $_notificationDataFactory;
        protected $_productRepositoryInterface;
        protected $_categoryRepositoryInterface;

        public function __construct(
            Context $context,
            \Webkul\Mobikul\Helper\Data $helper,
            \Magento\Framework\Filesystem $filesystem,
            \Magento\Framework\Registry $coreRegistry,
            \Magento\Framework\Json\Helper\Data $jsonHelper,
            \Magento\Ui\Component\MassAction\Filter $filter,
            \Magento\Catalog\Model\Product\Type $productType,
            \Magento\Framework\Stdlib\DateTime\DateTime $date,
            \Magento\Eav\Model\Entity\Attribute $entityAttribute,
            NotificationInterfaceFactory $notificationDataFactory,
            ProductRepositoryInterface $productRepositoryInterface,
            CategoryRepositoryInterface $categoryRepositoryInterface,
            \Magento\Store\Model\StoreManagerInterface $storeManager,
            \Magento\Catalog\Model\ResourceModel\Product\Flat $entityType,
            \Magento\Framework\View\Result\PageFactory $resultPageFactory,
            \Magento\Catalog\Model\ResourceModel\Product $productResource,
            \Magento\Catalog\Model\ResourceModel\Category $categoryResource,
            \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
            \Magento\MediaStorage\Model\File\UploaderFactory $fileUploaderFactory,
            \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory,
            \Webkul\Mobikul\Api\NotificationRepositoryInterface $notificationRepository,
            \Magento\Eav\Model\ResourceModel\Entity\Attribute\Set\Collection $attributeSet,
            \Webkul\Mobikul\Model\ResourceModel\Notification\CollectionFactory $collectionFactory
        ) {
            parent::__construct($context);
            $this->_date                        = $date;
            $this->_filter                      = $filter;
            $this->_helper                      = $helper;
            $this->_jsonHelper                  = $jsonHelper;
            $this->_entityType                  = $entityType;
            $this->_productType                 = $productType;
            $this->_coreRegistry                = $coreRegistry;
            $this->_storeManager                = $storeManager;
            $this->_attributeSet                = $attributeSet;
            $this->_entityAttribute             = $entityAttribute;
            $this->_productResource             = $productResource;
            $this->_categoryResource            = $categoryResource;
            $this->_collectionFactory           = $collectionFactory;
            $this->_resultJsonFactory           = $resultJsonFactory;
            $this->_resultPageFactory           = $resultPageFactory;
            $this->_fileUploaderFactory         = $fileUploaderFactory;
            $this->_resultForwardFactory        = $resultForwardFactory;
            $this->_notificationRepository      = $notificationRepository;
            $this->_notificationDataFactory     = $notificationDataFactory;
            $this->_productRepositoryInterface  = $productRepositoryInterface;
            $this->_categoryRepositoryInterface = $categoryRepositoryInterface;
            $this->_mediaDirectory              = $filesystem->getDirectoryWrite(DirectoryList::MEDIA);
        }

        protected function _isAllowed()     {
            return $this->_authorization->isAllowed("Webkul_Mobikul::notification");
        }

        protected function getDecodedText($string)
        {
            $allemojies = explode ('"', $string);
            $finalString = "";
            foreach ($allemojies as $emoji) {
                if (strpos($emoji, "\u") !== false ) {
                    $finalString = $finalString.json_decode('"'.$emoji.'"');
                } else {
                    $finalString = $finalString.$emoji;
                }
            }
            return $finalString;
        }

    }