<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Catalog;

    class RemoveFromCompare extends AbstractCatalog  {

        public function execute()  {
            $returnArray               = [];
            $returnArray["success"]    = false;
            $returnArray["message"]    = "";
            $returnArray["otherError"] = "";
            try  {
                $wholeData      = $this->getRequest()->getPostValue();
                $this->_headers = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData)  {
                    $authKey  = $this->getRequest()->getHeader("authKey");
                    $authData = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1)  {
                        $storeId       = $wholeData["storeId"]       ?? 1;
                        $productId     = $wholeData["productId"]     ?? 0;
                        $customerToken = $wholeData["customerToken"] ?? "";
                        $customerId    = $this->_helper->getCustomerByToken($customerToken) ?? 0;
                        $environment   = $this->_emulate->startEnvironmentEmulation($storeId);
// checking customer token //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                        if (!$customerId && $customerToken != "")  {
                            $returnArray["message"]    = __("As customer you are requesting does not exist, so you need to logout.");
                            $returnArray["otherError"] = "customerNotExist";
                            $customerId = 0;
                        }
// End checking customer token ////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
                        if ($productId != 0)  {
                            try  {
                                $product = $this->_productRepository->getById($productId, false, $storeId);
                            } catch (\NoSuchEntityException $e) {
                                $product = null;
                            }
                            if ($product)  {
                                $item = $this->_compareItemFactory->create();
                                if ($customerId != 0)
                                    $item->setCustomerId($customerId);
                                else
                                    $item->addVisitorId($this->_customerVisitor->getId());
                                $item->loadByProduct($product);
                                $helper = $this->_compare;
                                if ($item->getId())  {
                                    $item->delete();
                                    $returnArray["message"] = html_entity_decode(__("You removed product %1 from the comparison list.", $product->getName()));
                                    $this->_eventManager->dispatch("catalog_product_compare_remove_product", ["product"=>$item]);
                                    $helper->calculate();
                                }
                            }
                        }
                        $returnArray["success"] = true;
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else  {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else  {
                    $returnArray["message"] = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Exception $e)  {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }