<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Customer;
    use Magento\Store\Model\App\Emulation;
    use Magento\Framework\App\Action\Context;
    use Magento\Customer\Model\CustomerExtractor;
    use Webkul\Mobikul\Helper\Data as HelperData;
    use Webkul\Mobikul\Helper\Catalog as HelperCatalog;
    use Magento\Customer\Api\AccountManagementInterface;

    abstract class AbstractCustomer extends \Webkul\Mobikul\Controller\ApiController    {

        protected $_cart;
        protected $_vote;
        protected $_order;
        protected $_quote;
        protected $_review;
        protected $_visitor;
        protected $_country;
        protected $_baseDir;
        protected $_wishlist;
        protected $_userImage;
        protected $_encryptor;
        protected $_jsonHelper;
        protected $_localeDate;
        protected $_orderTotals;
        protected $_salesHelper;
        protected $_cartFactory;
        protected $_tokenHelper;
        protected $_compareItem;
        protected $_listProduct;
        protected $_orderConfig;
        protected $_quoteFactory;
        protected $_storeManager;
        protected $_wishlistItem;
        protected $_reviewHelper;
        protected $_customerList;
        protected $_customerForm;
        protected $_stockRegistry;
        protected $_catalogConfig;
        protected $_addressHelper;
        protected $_purchasedlink;
        protected $_invoiceTotals;
        protected $_priceRenderer;
        protected $_productHelper;
        protected $_pricingHelper;
        protected $_securityConfig;
        protected $_authentication;
        protected $_productFactory;
        protected $_customerMapper;
        protected $_wishlistHelper;
        protected $_orderInfoBlock;
        protected $_voteCollection;
        protected $_stockRepository;
        protected $_customerSession;
        protected $_customerAddress;
        protected $_orderCollection;
        protected $_customerFactory;
        protected $_customerRegistry;
        protected $_wishlistProvider;
        protected $_creditmemoTotals;
        protected $_reviewCollection;
        protected $_downloadableLink;
        protected $_dataObjectHelper;
        protected $_purchasedLinkItem;
        protected $_productVisibility;
        protected $_productRepository;
        protected $_accountManagement;
        protected $_emailNotification;
        protected $_customerExtractor;
        protected $_addressRepository;
        protected $_countryCollection;
        protected $_orderHistoryBlock;
        protected $_orderItemRenderer;
        protected $_collectionFactory;
        protected $_wishlistItemOption;
        protected $_downloadableHelper;
        protected $_downloadableFileHelper;
        protected $_purchasedLinkCollection;
        protected $_productCollectionFactory;
        protected $_catalogProductCompareList;
        protected $_productConfigurationHelper;
        protected $_customerRepositoryInterface;
        protected $_purchasedLinkItemCollection;

        public function __construct(
            Context $context,
            HelperData $helper,
            Emulation $emulate,
            HelperCatalog $helperCatalog,
            \Magento\Quote\Model\Quote $quote,
            \Magento\Sales\Model\Order $order,
            \Magento\Checkout\Model\Cart $cart,
            CustomerExtractor $customerExtractor,
            \Magento\Review\Model\Review $review,
            \Magento\Customer\Model\Visitor $visitor,
            \Magento\Review\Helper\Data $reviewHelper,
            \Webkul\Mobikul\Helper\Token $tokenHelper,
            \Magento\Directory\Model\Country $country,
            \Magento\Wishlist\Model\Item $wishlistItem,
            \Webkul\Mobikul\Model\UserImage $userImage,
            \Magento\Customer\Model\Form $customerForm,
            \Magento\Sales\Helper\Reorder $salesHelper,
            \Magento\Catalog\Model\Config $catalogConfig,
            AccountManagementInterface $accountManagement,
            \Magento\Wishlist\Helper\Data $wishlistHelper,
            \Magento\Sales\Model\Order\Config $orderConfig,
            \Magento\Review\Model\Rating\Option\Vote $vote,
            \Magento\Catalog\Helper\Product $productHelper,
            \Magento\Quote\Model\QuoteFactory $quoteFactory,
            \Magento\Customer\Helper\Address $addressHelper,
            \Magento\Sales\Block\Order\Info $orderInfoBlock,
            \Magento\Framework\Json\Helper\Data $jsonHelper,
            \Magento\Customer\Model\Session $customerSession,
            \Magento\Checkout\Model\CartFactory $cartFactory,
            \Magento\Framework\Filesystem\DirectoryList $dir,
            \Magento\Customer\Model\Address $customerAddress,
            \Magento\Wishlist\Model\WishlistFactory $wishlist,
            \Magento\Wishlist\Model\Wishlist $wishlistProvider,
            \Magento\Downloadable\Model\Link $downloadableLink,
            \Webkul\Mobikul\Block\Sales\Order\Totals $orderTotals,
            \Magento\Catalog\Model\ProductFactory $productFactory,
            \Magento\Framework\Pricing\Helper\Data $pricingHelper,
            \Magento\Sales\Block\Order\History $orderHistoryBlock,
            \Magento\Downloadable\Helper\Data $downloadableHelper,
            \Magento\Weee\Block\Item\Price\Renderer $priceRenderer,
            \Magento\Security\Model\ConfigInterface $securityConfig,
            \Magento\Catalog\Helper\Product\Compare $productCompare,
            \Magento\Wishlist\Model\Item\Option $wishlistItemOption,
            \Magento\Customer\Model\CustomerFactory $customerFactory,
            \Magento\Store\Model\StoreManagerInterface $storeManager,
            \Magento\Review\Block\Customer\ListCustomer $customerList,
            \Magento\Downloadable\Helper\File $downloadableFileHelper,
            \Magento\Framework\Api\DataObjectHelper $dataObjectHelper,
            \Magento\Downloadable\Model\Link\Purchased $purchasedlink,
            \Magento\Customer\Model\CustomerRegistry $customerRegistry,
            \Magento\Framework\Encryption\EncryptorInterface $encryptor,
            \Magento\Catalog\Model\Product\Visibility $productVisibility,
            \Webkul\Mobikul\Block\Sales\Order\Invoice\Totals $invoiceTotals,
            \Magento\Framework\Stdlib\DateTime\TimezoneInterface $localeDate,
            \Magento\Downloadable\Model\Link\Purchased\Item $purchasedLinkItem,
            \Magento\Catalog\Api\ProductRepositoryInterface $productRepository,
            \Magento\Customer\Api\AddressRepositoryInterface $addressRepository,
            \Magento\CatalogInventory\Api\StockRegistryInterface $stockRegistry,
            \Magento\Sales\Model\ResourceModel\Order\Collection $orderCollection,
            \Webkul\Mobikul\Block\Sales\Order\Creditmemo\Totals $creditmemoTotals,
            \Magento\Catalog\Model\ResourceModel\Product\Compare\Item $compareItem,
            \Magento\Downloadable\Block\Customer\Products\ListProducts $listProduct,
            \Magento\Review\Model\ResourceModel\Review\CollectionFactory $reviewCollection,
            \Magento\Catalog\Helper\Product\Configuration $productConfigurationHelper,
            \Magento\CatalogInventory\Model\Stock\StockItemRepository $stockRepository,
            \Magento\Sales\Block\Order\Item\Renderer\DefaultRenderer $orderItemRenderer,
            \Magento\Directory\Model\ResourceModel\Country\Collection $countryCollection,
            \Magento\Catalog\Model\Product\Compare\ListCompare $catalogProductCompareList,
            \Magento\Customer\Api\CustomerRepositoryInterface $customerRepositoryInterface,
            \Magento\Review\Model\ResourceModel\Review\Product\CollectionFactory $collectionFactory,
            \Magento\Review\Model\ResourceModel\Rating\Option\Vote\CollectionFactory $voteCollection,
            \Magento\Downloadable\Model\ResourceModel\Link\Purchased\Collection $purchasedLinkCollection,
            \Magento\Downloadable\Model\ResourceModel\Link\Purchased\Item\Collection $purchasedLinkItemCollection,
            \Magento\Catalog\Model\ResourceModel\Product\Compare\Item\CollectionFactory $productCollectionFactory
        ) {
            $this->_cart                        = $cart;
            $this->_vote                        = $vote;
            $this->_quote                       = $quote;
            $this->_order                       = $order;
            $this->_review                      = $review;
            $this->_emulate                     = $emulate;
            $this->_visitor                     = $visitor;
            $this->_country                     = $country;
            $this->_baseDir                     = $dir->getPath("media");
            $this->_wishlist                    = $wishlist;
            $this->_userImage                   = $userImage;
            $this->_encryptor                   = $encryptor;
            $this->_localeDate                  = $localeDate;
            $this->_jsonHelper                  = $jsonHelper;
            $this->_tokenHelper                 = $tokenHelper;
            $this->_salesHelper                 = $salesHelper;
            $this->_orderTotals                 = $orderTotals;
            $this->_cartFactory                 = $cartFactory;
            $this->_compareItem                 = $compareItem;
            $this->_orderConfig                 = $orderConfig;
            $this->_listProduct                 = $listProduct;
            $this->_storeManager                = $storeManager;
            $this->_customerForm                = $customerForm;
            $this->_reviewHelper                = $reviewHelper;
            $this->_customerList                = $customerList;
            $this->_quoteFactory                = $quoteFactory;
            $this->_wishlistItem                = $wishlistItem;
            $this->_pricingHelper               = $pricingHelper;
            $this->_catalogConfig               = $catalogConfig;
            $this->_addressHelper               = $addressHelper;
            $this->_helperCatalog               = $helperCatalog;
            $this->_stockRegistry               = $stockRegistry;
            $this->_purchasedlink               = $purchasedlink;
            $this->_priceRenderer               = $priceRenderer;
            $this->_productHelper               = $productHelper;
            $this->_invoiceTotals               = $invoiceTotals;
            $this->_securityConfig              = $securityConfig;
            $this->_productFactory              = $productFactory;
            $this->_orderInfoBlock              = $orderInfoBlock;
            $this->_wishlistHelper              = $wishlistHelper;
            $this->_voteCollection              = $voteCollection;
            $this->_productCompare              = $productCompare;
            $this->_customerAddress             = $customerAddress;
            $this->_stockRepository             = $stockRepository;
            $this->_orderCollection             = $orderCollection;
            $this->_customerFactory             = $customerFactory;
            $this->_customerSession             = $customerSession;
            $this->_customerRegistry            = $customerRegistry;
            $this->_downloadableLink            = $downloadableLink;
            $this->_wishlistProvider            = $wishlistProvider;
            $this->_dataObjectHelper            = $dataObjectHelper;
            $this->_reviewCollection            = $reviewCollection;
            $this->_creditmemoTotals            = $creditmemoTotals;
            $this->_purchasedLinkItem           = $purchasedLinkItem;
            $this->_collectionFactory           = $collectionFactory;
            $this->_productVisibility           = $productVisibility;
            $this->_productRepository           = $productRepository;
            $this->_accountManagement           = $accountManagement;
            $this->_addressRepository           = $addressRepository;
            $this->_customerExtractor           = $customerExtractor;
            $this->_countryCollection           = $countryCollection;
            $this->_orderHistoryBlock           = $orderHistoryBlock;
            $this->_orderItemRenderer           = $orderItemRenderer;
            $this->_downloadableHelper          = $downloadableHelper;
            $this->_wishlistItemOption          = $wishlistItemOption;
            $this->_downloadableFileHelper      = $downloadableFileHelper;
            $this->_purchasedLinkCollection     = $purchasedLinkCollection;
            $this->_productCollectionFactory    = $productCollectionFactory;
            $this->_catalogProductCompareList   = $catalogProductCompareList;
            $this->_productConfigurationHelper  = $productConfigurationHelper;
            $this->_customerRepositoryInterface = $customerRepositoryInterface;
            $this->_purchasedLinkItemCollection = $purchasedLinkItemCollection;
            parent::__construct($helper, $context);
        }

    }
