<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Customer;

    class SaveAddress extends AbstractCustomer  {

        public function execute()   {
            $returnArray               = [];
            $returnArray["success"]    = false;
            $returnArray["message"]    = "";
            $returnArray["otherError"] = "";
            try {
                $wholeData       = $this->getRequest()->getPostValue();
                $this->_headers  = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey     = $this->getRequest()->getHeader("authKey");
                    $authData    = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $storeId       = $wholeData["storeId"]       ?? 1;
                        $addressId     = $wholeData["addressId"]     ?? 0;
                        $addressData   = $wholeData["addressData"]   ?? "[]";
                        $customerToken = $wholeData["customerToken"] ?? "";
                        $customerId    = $this->_helper->getCustomerByToken($customerToken);
// checking customer token //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                        if (!$customerId && $customerToken != "")  {
                            $returnArray["otherError"] = "customerNotExist";
                            throw new \Magento\Framework\Exception\LocalizedException(
                                __("As customer you are requesting does not exist, so you need to logout.")
                            );
                        }
// end checking customer token ////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
                        $addressData = $this->_jsonHelper->jsonDecode($addressData);
                        $environment = $this->_emulate->startEnvironmentEmulation($storeId);
                        $addressDataArr = [];
                        foreach ($addressData as $key=>$addressValue)
                            $addressDataArr[$key] = $addressValue;
                        $customer = $this->_customerFactory->create()->load($customerId);
                        $customerSession = $this->_customerSession->setCustomer($customer);
                        $address  = $this->_customerAddress;
                        if ($addressId != 0) {
                            $existsAddress = $customer->getAddressById($addressId);
                            if ($existsAddress->getId() && $existsAddress->getCustomerId() == $customer->getId()) {
                                $address->setId($existsAddress->getId());
                            }
                        }
                        $errors        = [];
                        $addressForm   = $this->_customerForm;
                        $addressForm->setFormCode("customer_address_edit")->setEntity($address);
                        $addressErrors = $addressForm->validateData($addressDataArr);
                        if ($addressErrors !== true)
                            $errors = $addressErrors;
                        $addressForm->compactData($addressDataArr);
                        $address->setCustomerId($customerId)
                            ->setIsDefaultBilling($addressDataArr["default_billing"])
                            ->setIsDefaultShipping($addressDataArr["default_shipping"]);
                        $addressErrors = $address->validate();
                        $address->save();
                        $returnArray["message"] = __("The address has been saved.");
                        $returnArray["success"] = true;
                        $this->_emulate->stopEnvironmentEmulation($environment);
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Magento\Framework\Exception\LocalizedException $e) {
                $returnArray["message"] = __($e->getMessage());
                return $this->getJsonResponse($returnArray);    
            } catch (\Exception $e) {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }