<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Customer;

    class SaveReview extends AbstractCustomer   {

        public function execute()   {
            $returnArray               = [];
            $returnArray["success"]    = false;
            $returnArray["message"]    = "";
            $returnArray["otherError"] = "";
            try {
                $wholeData       = $this->getRequest()->getPostValue();
                $this->_headers  = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey     = $this->getRequest()->getHeader("authKey");
                    $authData    = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $title         = $wholeData["title"]         ?? "";
                        $detail        = $wholeData["detail"]        ?? "";
                        $ratings       = $wholeData["ratings"]       ?? "[]";
                        $storeId       = $wholeData["storeId"]       ?? 1;
                        $nickname      = $wholeData["nickname"]      ?? "";
                        $productId     = $wholeData["productId"]     ?? 0;
                        $customerToken = $wholeData["customerToken"] ?? "";
                        $customerId    = $this->_helper->getCustomerByToken($customerToken);
                        $ratings     = $this->_objectManager->create("Magento\Framework\Json\Helper\Data")->jsonDecode($ratings);
                        $environment = $this->_emulate->startEnvironmentEmulation($storeId);   
// checking customer token //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                        if (!$customerId && $customerToken != "")  {
                            $returnArray["message"] = __("As customer you are requesting does not exist, so you need to logout.");
                            $returnArray["otherError"] = "customerNotExist";
                            $customerId = 0;
                        }
// end checking customer token ////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
                        if ($customerId == 0)
                            $customerId = NULL;
                        $review = $this->_objectManager->create("\Magento\Review\Model\Review")
                            ->setEntityPkValue($productId)
                            ->setStatusId(\Magento\Review\Model\Review::STATUS_PENDING)
                            ->setTitle($title)
                            ->setDetail($detail)
                            ->setEntityId(1)
                            ->setStoreId($storeId);
                        if((bool)$this->_helper->getConfigData("catalog/review/allow_guest") && $customerId != 0)
                            $review->setCustomerId($customerId);
                        $review->setNickname($nickname)
                            ->setReviewId($review->getId())
                            ->setStores([$storeId])
                            ->save();
                        foreach ($ratings as $ratingId=>$optionId) {
                            $this->_objectManager->create("\Magento\Review\Model\Rating")
                                ->setRatingId($ratingId)
                                ->setReviewId($review->getId())
                                ->setCustomerId($customerId)
                                ->addOptionVote($optionId, $productId);
                        }
                        $review->aggregate();
                        $returnArray["message"] = __("Your review has been accepted for moderation.");
                        $returnArray["success"] = true;
                        $this->_emulate->stopEnvironmentEmulation($environment);
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Magento\Framework\Exception\LocalizedException $e) {
                $returnArray["message"] = __($e->getMessage());
                return $this->getJsonResponse($returnArray);    
            } catch (\Exception $e) {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }