<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Downloadlink;

    use Magento\Framework\Controller\ResultFactory;

    class OpenApp extends \Magento\Framework\App\Action\Action    {

        protected $_helper;
        protected $resultRedirect;
        protected $_responseFactory;

        public function __construct(
            \Webkul\Mobikul\Helper\Data $helper,
            \Magento\Framework\App\Action\Context $context,
            \Magento\Framework\App\Response\HttpFactory $httpFactory
        ) {
            $this->_helper          = $helper;
            $this->_responseFactory = $httpFactory;
            parent::__construct($context);
        }

        public function execute()   {
            $url            = $this->_helper->getConfigData("mobikul/appdownload/androidlink");
            $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
            $resultRedirect->setUrl($url);
            return $resultRedirect; 
        }
    }
