<?php
    /**
    * Webkul Software.
    *
    * @category Webkul
    *
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Helper;
    use Magento\Framework\Stdlib\DateTime\DateTime;

    class Token extends \Magento\Framework\App\Helper\AbstractHelper  {

        protected $_date;
        protected $_helper;
        protected $_deviceToken;
        protected $_storeManager;

        public function __construct(
            \Webkul\Mobikul\Helper\Data $helper,
            \Magento\Framework\App\Helper\Context $context,
            \Webkul\Mobikul\Model\DeviceTokenFactory $deviceToken,
            \Magento\Store\Model\StoreManagerInterface $storeManager
        )  {
            $this->_helper       = $helper;
            $this->_deviceToken  = $deviceToken;
            $this->_storeManager = $storeManager;
            parent::__construct($context);
        }

        public function saveToken($customerId, $token, $os)  {
            try  {
                $deviceTokenModel = $this->_deviceToken->create();
                if ($customerId != "" && $token != "")  {
                    $collection = $deviceTokenModel->getCollection()->addFieldToFilter("token", $token);
                    if ($collection->getSize() > 0)  {
                        foreach ($collection as $eachRow)  {
                            $this->_deviceToken->create()->load($eachRow->getId())->setCustomerId($customerId)->setEmail("")->save();
                            return $eachRow->getId();
                        }
                    } else  {
                        return $this->_deviceToken->create()->setToken($token)->setCustomerId($customerId)->setOs($os)->save()->getId();
                    }
                }
                if ($customerId == "" && $token != "")  {
                    $collection = $deviceTokenModel->getCollection()->addFieldToFilter("token", $token);
                    if ($collection->getSize() > 0)  {
                        foreach ($collection as $eachRow)  {
                            $this->_deviceToken->create()->load($eachRow->getId())->setCustomerId($customerId)->save();
                            return $eachRow->getId();
                        }
                    } else  {
                        return $this->_deviceToken->create()->setToken($token)->setCustomerId($customerId)->setOs($os)->save()->getId();
                    }
                }
            } catch (\Exception $e)  {
                $this->_helper->printLog($e->getMessage(), 1);
            }
        }
    }