<?php
/**
* Webkul Software.
*
* @category  Webkul
* @package   Webkul_Mobikul
* @author    Webkul
* @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
* @license   https://store.webkul.com/license.html
*/

    namespace Webkul\Mobikul\Ui\Component\Listing\Column;
    use Magento\Framework\Escaper;
    use Magento\Ui\Component\Listing\Columns\Column;
    use Magento\Store\Model\System\Store as SystemStore;
    use Magento\Framework\View\Element\UiComponentFactory;
    use Magento\Store\Model\StoreManagerInterface as StoreManager;
    use Magento\Framework\View\Element\UiComponent\ContextInterface;

    class Store extends \Magento\Store\Ui\Component\Listing\Column\Store    {

        protected $request;

        public function __construct(
            \Magento\Framework\App\Request\Http $request,
            ContextInterface $context,
            UiComponentFactory $uiComponentFactory,
            SystemStore $systemStore,
            Escaper $escaper,
            array $components = [],
            array $data = [],
            $storeKey = "store_id"
        ) {
            $this->request = $request;
            parent::__construct($context, $uiComponentFactory, $systemStore, $escaper, $components, $data, $storeKey);
        }

        protected function prepareItem(array $item)     {
            if ($this->request->getParam("namespace") == "mobikul_notification_list" && is_string($item[$this->storeKey])) {
                $item[$this->storeKey] = explode(",", $item[$this->storeKey]);
            }
            return parent::prepareItem($item);
        }

    }